//+------------------------------------------------------------------+
//|                                                  LR R2 trend.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1 Green
#property indicator_color2 DarkGreen
#property indicator_color3 Red
#property indicator_color4 Maroon
#property indicator_color5 SlateBlue
#property indicator_color6 DimGray
#property indicator_color7 Yellow

#property indicator_width1 2
#property indicator_width3 2
#property indicator_width5 2
#property indicator_width6 1
#property indicator_width7 1

//
//
//
//
//

extern int    Length           = 34;
extern int    AppliedPrice     = PRICE_CLOSE;

extern int       BBSqzPrd = 20;
extern double    SqzSigLevel = 0.00004;//0;

int       bolPrd  = 20;  
double    bolDev  = 2.0;
int       keltPrd = 20;
double    keltFactor= 1.5;


extern string TimeFrame       = "current timeframe";
extern string note_TimeFrames = "M1;5,15,30,60H1;240H4;1440D1;10080W1;43200MN|0-currentTF";





//
//
//
//
//

double Buffer[];
double LRSBuffer[];
double LRSBufferUa[];
double LRSBufferUb[];
double LRSBufferDa[];
double LRSBufferDb[];
double RSQBuffer[];
double BBSqBuffer[];

//
//
//
//
//

int    timeFrame;
double Trending;
string IndicatorFileName;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorDigits(5);
   IndicatorBuffers(8);
   SetIndexBuffer(0,LRSBufferUa); SetIndexLabel(0,"LR up");
   SetIndexBuffer(1,LRSBufferUb); SetIndexLabel(1,"LR weak up");
   SetIndexBuffer(2,LRSBufferDa); SetIndexLabel(2,"LR down");
   SetIndexBuffer(3,LRSBufferDb); SetIndexLabel(3,"LR weak down");
   SetIndexBuffer(4,Buffer);      SetIndexLabel(4,"no trend");
   SetIndexBuffer(5,LRSBuffer);   SetIndexLabel(5,"LR regression slope");
   SetIndexBuffer(6,BBSqBuffer);  SetIndexLabel(6,"BB Squeeze");
   SetIndexBuffer(7,RSQBuffer);

   for (int i = 0; i < 4; i++) SetIndexStyle(i,DRAW_HISTOGRAM);
            SetIndexStyle(4,DRAW_ARROW);
            SetIndexArrow(4,158);
            SetIndexStyle(6,DRAW_ARROW);
            SetIndexArrow(6,158);
   
   //
   //
   //
   //
   //
  
   timeFrame = stringToTimeFrame(TimeFrame);
   IndicatorShortName("LRR2Trend "+TimeFrameToString(timeFrame)+" ("+Length+")");
   IndicatorFileName = WindowExpertName();
   Trending = 3.858889/Length;
   return(0);
}

//
//
//
//
//

int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{

   int  counted_bars=IndicatorCounted();
   int  i,y,limit;

   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
       limit=Bars-counted_bars;

  // //

   //
   //
   //
   
   if (timeFrame != Period())
   {
      datetime TimeArray[];
         limit = MathMax(limit,timeFrame/Period());
         ArrayCopySeries(TimeArray ,MODE_TIME ,NULL,timeFrame);
         
         //
         //
         //
         //
         //
         
         for(i=0,y=0; i<limit; i++)
         {
            if(Time[i]<TimeArray[y]) y++;
            LRSBufferUa[i] = iCustom(NULL,timeFrame,IndicatorFileName,Length,AppliedPrice,BBSqzPrd,SqzSigLevel,0,y);
            LRSBufferUb[i] = iCustom(NULL,timeFrame,IndicatorFileName,Length,AppliedPrice,BBSqzPrd,SqzSigLevel,1,y);
            LRSBufferDa[i] = iCustom(NULL,timeFrame,IndicatorFileName,Length,AppliedPrice,BBSqzPrd,SqzSigLevel,2,y);
            LRSBufferDb[i] = iCustom(NULL,timeFrame,IndicatorFileName,Length,AppliedPrice,BBSqzPrd,SqzSigLevel,3,y);
            Buffer[i]      = iCustom(NULL,timeFrame,IndicatorFileName,Length,AppliedPrice,BBSqzPrd,SqzSigLevel,4,y);
            LRSBuffer[i]   = iCustom(NULL,timeFrame,IndicatorFileName,Length,AppliedPrice,BBSqzPrd,SqzSigLevel,5,y);
            BBSqBuffer[i]  = iCustom(NULL,timeFrame,IndicatorFileName,Length,AppliedPrice,BBSqzPrd,SqzSigLevel,6,y);

          }
       return(0);         
     }
         
   //
   //
   //
   //
   //
 
   double diff,std,bbs;

   for (i=limit;i>=0;i--)
   {
      
     
      bolPrd  =BBSqzPrd;
      keltPrd =  BBSqzPrd;    
      diff = iATR(NULL,0,keltPrd,i)*keltFactor;
		std = iStdDev(NULL,0,bolPrd,MODE_SMA,0,PRICE_CLOSE,i);
//  	bbs = bolDev * std / diff;   //!zero divide!
      if (diff != 0)
          bbs = bolDev * std / diff;
      else  bbs = 0;  
     
     
      if(bbs<1) 
        {

        if (LRSBuffer[i]>0)
            BBSqBuffer[i]= SqzSigLevel;
        else
            BBSqBuffer[i]= -SqzSigLevel;
         } 
      else 
            {
            BBSqBuffer[i]=EMPTY_VALUE;
            }
  
   //
   //
   //
 
      
      LRSBuffer[i] = LinearRegressionSlope(Length,i);
      RSQBuffer[i] = RSquared(Length,i);
      
      //
      //
      //
      //
      //

      Buffer[i]      = EMPTY_VALUE;
      LRSBufferUa[i] = EMPTY_VALUE;
      LRSBufferUb[i] = EMPTY_VALUE;
      LRSBufferDa[i] = EMPTY_VALUE;
      LRSBufferDb[i] = EMPTY_VALUE;
 
         if (RSQBuffer[i] < Trending) { Buffer[i] = 0.00; continue; }
         if (LRSBuffer[i] > 0)
         {
            if (LRSBuffer[i] > LRSBuffer[i+1]) { LRSBufferUa[i] = LRSBuffer[i]; LRSBufferUb[i] = EMPTY_VALUE; }
            if (LRSBuffer[i] < LRSBuffer[i+1]) { LRSBufferUb[i] = LRSBuffer[i]; LRSBufferUa[i] = EMPTY_VALUE; }                     
         }
         if (LRSBuffer[i] < 0)
         {
            if (LRSBuffer[i] < LRSBuffer[i+1]) { LRSBufferDa[i] = LRSBuffer[i]; LRSBufferDb[i] = EMPTY_VALUE; }
            if (LRSBuffer[i] > LRSBuffer[i+1]) { LRSBufferDb[i] = LRSBuffer[i]; LRSBufferDa[i] = EMPTY_VALUE; }                     
         }
 




        


  }

   //
   //
   //
   //
   //


 
   
   for(i=0;i<indicator_buffers;i++) SetIndexDrawBegin(i,Length); 


   return(0);
}


//---------------------------------------------------------------------------------|
//                                                                                 |
//---------------------------------------------------------------------------------|
//
//
//
//
//

int    lrs_period=EMPTY_VALUE;
double lrs_sumX;
double lrs_sumXSqr;
double lrs_divisor;

//
//
//
//
//

double LinearRegressionSlope(int len,int shift)
{
   double LinearRegSlope;
   double SumXY = 0;
   double SumY  = 0;

   //
   //
   //
   //
   //

   if (lrs_period != len)
   {
      lrs_period  = len;
      lrs_sumX    = lrs_period * (lrs_period-1) / 2;
      lrs_sumXSqr = lrs_period * (lrs_period-1) * (2 * lrs_period - 1) / 6;
      lrs_divisor = MathPow(lrs_sumX,2) - lrs_period * lrs_sumXSqr;
   }

   //
   //
   //
   //
   //

   for (int i=0; i<lrs_period; i++)
   {
      double price = iMA(NULL,0,1,0,MODE_EMA,AppliedPrice,i+shift);
            SumXY += i*price;
            SumY  +=   price;
   }
   if( lrs_divisor != 0 ) 
         	LinearRegSlope = (lrs_period * SumXY - lrs_sumX * SumY)/lrs_divisor;
   else     LinearRegSlope = 0; 
   return  (LinearRegSlope);
}


//---------------------------------------------------------------------------------|
//                                                                                 |
//---------------------------------------------------------------------------------|
//
//
//
//
//

double lrs_len = EMPTY_VALUE;
double lrs_SumX;
double lrs_SumY;
double lrs_SumX2;
double lrs_SumY2;
double lrs_SumXY;
double lrs_SumR;

//
//
//
//
//

double RSquared(int Len,int shift)
{
   double RSquared;
   double price;
   double Q1;
   double Q2;
   double Q3;
   int    i;


   if (lrs_len != Len)
      {
         lrs_len = Len;
         lrs_SumX  = 0; for(i=0;i<=Len-1;i++) lrs_SumX  += i+1;
         lrs_SumX2 = 0; for(i=0;i<=Len-1;i++) lrs_SumX2 += (i+1)*(i+1);
      }         
   
      lrs_SumY  = 0;
      lrs_SumY2 = 0;
      lrs_SumXY = 0;
      
      //
      //
      //
      //
      //
      
      for(i=0;i<Len;i++)
         {
            price = iMA(NULL,0,1,0,MODE_EMA,AppliedPrice,i+shift);
                lrs_SumY  +=         price;
                lrs_SumY2 += MathPow(price,2);
                lrs_SumXY +=   (i+1)*price;
         }             
         Q1 = lrs_SumXY - lrs_SumX*lrs_SumY/Len;
         Q2 = lrs_SumX2 - lrs_SumX*lrs_SumX/Len;
         Q3 = lrs_SumY2 - lrs_SumY*lrs_SumY/Len;
         
         //
         //
         //
         //
         //
         
         if( Q2*Q3 != 0 ) RSquared = Q1*Q1/(Q2*Q3);
         else             RSquared = 0; 







   return(RSquared);
}


//+------------------------------------------------------------------+
//|
//+------------------------------------------------------------------+
//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   int tf=0;
       tfs = StringTrimLeft(StringTrimRight(StringUpperCase(tfs)));
         if (tfs=="M1" || tfs=="1M" ||tfs=="1" )              tf=PERIOD_M1;
         if (tfs=="M5" || tfs=="5M" ||tfs=="5" )              tf=PERIOD_M5;
         if (tfs=="M15"|| tfs=="15M"||tfs=="15")              tf=PERIOD_M15;
         if (tfs=="M30"|| tfs=="30M"||tfs=="30")              tf=PERIOD_M30;
         if (tfs=="H1" || tfs=="1H" ||tfs=="60" ||  tfs=="H" )  tf=PERIOD_H1;
         if (tfs=="H4" || tfs=="4H" ||tfs=="240")               tf=PERIOD_H4;
         if (tfs=="D1" || tfs=="1D" ||tfs=="1440" || tfs=="D")  tf=PERIOD_D1;
         if (tfs=="W1" || tfs=="1W" ||tfs=="10080"|| tfs=="W")  tf=PERIOD_W1;
         if (tfs=="MN" || tfs=="MN1"||tfs=="43200"|| tfs=="1MN")tf=PERIOD_MN1;
         if (tf<Period()) tf=Period();
  return(tf);
}
string TimeFrameToString(int tf)
{
   string tfs="";
   
   if (tf!=Period())
      switch(tf) {
         case PERIOD_M1:  tfs="M1"  ; break;
         case PERIOD_M5:  tfs="M5"  ; break;
         case PERIOD_M15: tfs="M15" ; break;
         case PERIOD_M30: tfs="M30" ; break;
         case PERIOD_H1:  tfs="H1"  ; break;
         case PERIOD_H4:  tfs="H4"  ; break;
         case PERIOD_D1:  tfs="D1"  ; break;
         case PERIOD_W1:  tfs="W1"  ; break;
         case PERIOD_MN1: tfs="MN1";
      }
   return(tfs);
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;
   int      lenght = StringLen(str) - 1;
   int      tchar;
   
   while(lenght >= 0)
      {
         tchar = StringGetChar(s, lenght);
         
         //
         //
         //
         //
         //
         
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                  s = StringSetChar(s, lenght, tchar - 32);
         else 
              if(tchar > -33 && tchar < 0)
                  s = StringSetChar(s, lenght, tchar + 224);
         lenght--;
   }
   
   //
   //
   //
   //
   //
   
   return(s);
}